EDIT - bug #9710

DatalntegrityViolationException after adding a specimen to the matrix
07/15/2021 09:16 AM - Andreas Mdller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 100%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.27

Severity: critical Found in Version:

Description

Murat:

| come across this error message when | add a new specimen to the matrix.
Do | have to reopen the matrix when | make this addition? In this case, the matrix opens very slowly due to the large dataset.

AM:

as far as | understand this error returns repeatedly. Did you recognize any pattern when it does occur? E.g. always when you add a
new specimen to the matrix? Or always when working on a new taxon ...?

Murat:
| got the following error message several times when | tried to save my recent works.

| always reopen the EDIT to fix the problem. However, this is not convenient because it opens too slow. It takes more than two
minutes for each samples.

last remote method : http://api.cybertaxonomy.org:80/flora—greece-bupleurum/remoting/description.s

ervice

last remote request client time : 2021-07-14T11:17:15.244

last remote request response header time : Wed, 14 Jul 2021 09:17:15 GMT

client error time : 2021-07-14T11:17:17.167

login : m.guezel

editor version : 5.24.0

server : apil.cybertaxonomy.org (cybertaxonomy.org) / flora-greece-bupleurum

schema version : 5.23.0.0.20210422

os : Windows 7 6.1 amdé64

java : 1.8.0_121

org.eclipse.ed.core.di.InjectionException: org.springframework.dao.DatalntegrityViolationException
could not execute statement; SQL [n/a]; constraint [UK_b8inp8ckel89cpod7euwnObgf]; nested except

ion is org.hibernate.exception.ConstraintViolationException: could not execute statement

at org.eclipse.ed.core.internal.di.MethodRequestor.execute (MethodRequestor. java:65)

at org.eclipse.ed.core.internal.di.InjectorImpl.invokeUsingClass (InjectorImpl. java:282)

at org.eclipse.ed.core.internal.di.InjectorImpl.invoke (InjectorImpl. java:247)

at org.eclipse.ed.core.contexts.ContextInjectionFactory.invoke (ContextInjectionFactory. java:90)

at org.eclipse.e4d4.ui.internal.workbench.PartServiceSaveHandler.save (PartServiceSaveHandler. java:57

)

at org.eclipse.ui.internal.WorkbenchWindow$7.save (WorkbenchWindow. java:594)

at org.eclipse.ed.ui.internal.workbench.PartServiceImpl.savePart (PartServiceImpl.java:1390)

at eu.etaxonomy.taxeditor.workbench.SaveHandler.execute (SaveHandler. java:38)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.eclipse.ed.core.internal.di.MethodRequestor.execute (MethodRequestor. java:55)

at org.eclipse.ed.core.internal.di.InjectorImpl.invokeUsingClass (InjectorImpl. java:282)

at org.eclipse.ed.core.internal.di.InjectorImpl.invoke (InjectorImpl.java:264)

at org.eclipse.ed.core.contexts.ContextInjectionFactory.invoke (ContextInjectionFactory. java:132)

at org.eclipse.ed.core.commands.internal.HandlerServiceHandler.execute (HandlerServiceHandler. java:

152)

at org.eclipse.core.commands.Command.executeWithChecks (Command. java:494)
at org.eclipse.core.commands.ParameterizedCommand.executeWithChecks (ParameterizedCommand. java:488)
at org.eclipse.ed.core.commands.internal.HandlerServiceImpl.executeHandler (HandlerServiceImpl. java
:210)

at org.eclipse.ed.ui.workbench.renderers.swt.HandledContributionItem.executeltem (HandledContributi
onltem. java:433)

at org.eclipse.e4d.ui.workbench.renderers.swt.AbstractContributionItem.handleWidgetSelection (Abstra
ctContributionItem. java:454)

at org.eclipse.ed.ui.workbench.renderers.swt.AbstractContributionItem$3.handleEvent (AbstractContri
butionItem. java:482)

at org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)

at org.eclipse.swt.widgets.Display.sendEvent (Display.java:4418)

at org.eclipse.swt.widgets.Widget.sendEvent (Widget. java:1079)

at org.eclipse.swt.widgets.Display.runDeferredEvents (Display.java:4236)

at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:3824)

at org.eclipse.ed.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderingEngine. java:112
1)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.ed.ui.internal.workbench.swt.PartRenderingEngine.run (PartRenderingEngine. java:1022)
at org.eclipse.ed4.ui.internal.workbench.E4Workbench.createAndRunUI (E4Workbench. java:150)

at org.eclipse.ui.internal.Workbench$5.run (Workbench. java:693)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:610)

at org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:148)

at eu.etaxonomy.taxeditor.Application.start (Application. java:20)

at org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle. java:196)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLlauncher.runApplication (EclipseAppLauncher.
Jjava:134)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLauncher. java:104)
at org.eclipse.core.runtime.adaptor.EclipseStarter.run (EclipseStarter. java:388)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run (EclipseStarter. java:243)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:673)

at org.eclipse.equinox.launcher.Main.basicRun (Main. java:610)

at org.eclipse.equinox.launcher.Main.run (Main.java:1519)

Caused by: org.springframework.dao.DatalIntegrityViolationException: could not execute statement; S
QL [n/a]; constraint [UK _b8inp8ckel89cpod7euwnObgf]; nested exception is org.hibernate.exception.C
onstraintViolationException: could not execute statement

at org.springframework.orm.hibernate5.SessionFactoryUtils.convertHibernateAccessException (SessionF
actoryUtils. java:241)

at org.springframework.orm.hibernateb5.HibernateTransactionManager.convertHibernateAccessException (
HibernateTransactionManager. java:755)

at org.springframework.orm.hibernate5.HibernateTransactionManager.doCommit (HibernateTransactionMan
ager.java:590)

at org.springframework.transaction.support.AbstractPlatformTransactionManager.processCommit (Abstra
ctPlatformTransactionManager. java:765)

at org.springframework.transaction.support.AbstractPlatformTransactionManager.commit (AbstractPlatf
ormTransactionManager. java:734)

at org.springframework.transaction.interceptor.TransactionAspectSupport.commitTransactionAfterRetu
rning (TransactionAspectSupport. java:522)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(Tr
ansactionAspectSupport. java:293)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionIntercepto
r.java:96)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation
.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:213)

at com.sun.proxy.SProxyl870.mergeDescriptions (Unknown Source)

at sun.reflect.GeneratedMethodAccessor282580.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:333)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (ReflectiveMethodIn
vocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation
.java:157)

at org.springframework.remoting.support.RemoteInvocationTracelInterceptor.invoke (RemoteInvocationTr
acelnterceptor. java:78)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation
.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:213)

at com.sun.proxy.S$Proxy2206.mergeDescriptions (Unknown Source)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.remoting.support.RemoteInvocation.invoke (RemotelInvocation. java:212)

at eu.etaxonomy.cdm.api.remoting.DebuggingRemoteInvocationExecutor.invoke (DebuggingRemoteInvocatio
nExecutor. java:52)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invoke (RemoteInvocationBased
Exporter.java:78)

at org.springframework.remoting. support.RemoteInvocationBasedExporter.invokeAndCreateResult (Remote
InvocationBasedExporter.java:114)

at org.springframework.remoting.httpinvoker.HttpInvokerServiceExporter.handleRequest (HttpInvokerSe
rviceExporter. java:80)

at org.springframework.web.servlet.mvc.HttpRequestHandlerAdapter.handle (HttpRequestHandlerAdapter.
java:51)

at org.springframework.web.servlet.DispatcherServlet.doDispatch (DispatcherServlet.java:967)

at org.springframework.web.servlet.DispatcherServlet.doService (DispatcherServlet. java:901)

at org.springframework.web.servlet.FrameworkServlet.processRequest (FrameworkServlet. java:970)

at org.springframework.web.servlet.FrameworkServlet.doPost (FrameworkServlet. java:872)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:707)

at org.springframework.web.servlet.FrameworkServlet.service (FrameworkServlet.java:846)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:790)

at org.eclipse.jetty.servlet.ServletHolder$SNotAsyncServlet.service (ServletHolder.java:1395)

at org.eclipse.jetty.servlet.ServletHolder.handle (ServletHolder.java:755)

at org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler.java:1617)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.
java:317)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.invoke (FilterSecuri
tyInterceptor.java:127)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.doFilter (FilterSecu
rityInterceptor.java:91)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.
java:331)

at org.springframework.security.web.access.ExceptionTranslationFilter.doFilter (ExceptionTranslatio
nFilter.java:114)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.
java:331)

at org.springframework.security.web.session.SessionManagementFilter.doFilter (SessionManagementFilt
er.java:137)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.
java:331)

at org.springframework.security.web.servletapi.SecurityContextHolderAwareRequestFilter.doFilter (Se
curityContextHolderAwareRequestFilter. java:170)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.
java:331)

at org.springframework.security.web.savedrequest.RequestCacheAwareFilter.doFilter (RequestCacheAwar
eFilter. java:63)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.
java:331)

at org.springframework.security.web.authentication.www.BasicAuthenticationFilter.doFilterInternal (
BasicAuthenticationFilter. java:215)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.
java:331)

at org.springframework.security.web.authentication.logout.LogoutFilter.doFilter (LogoutFilter. java:
116)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.
java:331)

at org.springframework.security.web.header.HeaderWriterFilter.doFilterInternal (HeaderWriterFilter.
java:66)
at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.
java:331)

at org.springframework.security.web.context.SecurityContextPersistenceFilter.doFilter (SecurityCont
extPersistenceFilter.java:105)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.
java:331)

at org.springframework.security.web.context.request.async.WebAsyncManagerIntegrationFilter.doFilte
rInternal (WebAsyncManagerIntegrationFilter.java:56)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.
java:331)

at org.springframework.security.web.FilterChainProxy.doFilterInternal (FilterChainProxy. java:214)
at org.springframework.security.web.FilterChainProxy.doFilter (FilterChainProxy.java:177)

at org.springframework.web.filter.DelegatingFilterProxy.invokeDelegate (DelegatingFilterProxy. java:
347)

at org.springframework.web.filter.DelegatingFilterProxy.doFilter (DelegatingFilterProxy. java:263)
at org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1604)

at eu.etaxonomy.cdm.servlet.DateHeaderFilter.doFilter (DateHeaderFilter. java:55)

at org.eclipse.jetty.servlet.ServletHandler$SCachedChain.doFilter (ServletHandler. java:1604)

at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal (CharacterEncodingFilter
.java:197)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)

at org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1596)

at org.eclipse.jetty.servlet.ServletHandler.doHandle (ServletHandler.java:545)

at org.eclipse.jetty.server.handler.ScopedHandler.handle (ScopedHandler. java:143)

at org.eclipse.jetty.security.SecurityHandler.handle (SecurityHandler. java:590)

at org.eclipse.jetty.server.handler.HandlerWrapper.handle (HandlerWrapper.java:127)

at org.eclipse.jetty.server.handler.ScopedHandler.nextHandle (ScopedHandler. java:235)

at org.eclipse.jetty.server.session.SessionHandler.doHandle (SessionHandler. java:1607)

at org.eclipse.jetty.server.handler.ScopedHandler.nextHandle (ScopedHandler. java:233)

at org.eclipse.jetty.server.handler.ContextHandler.doHandle (ContextHandler. java:1297)

at org.eclipse.jetty.server.handler.ScopedHandler.nextScope (ScopedHandler. java:188)

at org.eclipse.jetty.servlet.ServletHandler.doScope (ServletHandler. java:485)

at org.eclipse.jetty.server.session.SessionHandler.doScope (SessionHandler. java:1577)

at org.eclipse.jetty.server.handler.ScopedHandler.nextScope (ScopedHandler.java:186)

at org.eclipse.jetty.server.handler.ContextHandler.doScope (ContextHandler.java:1212)

at org.eclipse.jetty.server.handler.ScopedHandler.handle (ScopedHandler. java:141)

at org.eclipse.jetty.server.handler.HandlerWrapper.handle (HandlerWrapper.java:127)

at eu.etaxonomy.cdm.server.logging.InstanceLogWrapper.handle (InstanceLogWrapper.java:47)

at org.eclipse.jetty.server.handler.ContextHandlerCollection.handle (ContextHandlerCollection. java:
221)

at org.eclipse.jetty.server.handler.HandlerWrapper.handle (HandlerWrapper.java:127)

at org.eclipse.jetty.server.Server.handle (Server. java:500)

at org.eclipse.jetty.server.HttpChannel.lambda$handle$l (HttpChannel. java:383)

at org.eclipse.jetty.server.HttpChannel.dispatch (HttpChannel. java:547)

at org.eclipse.jetty.server.HttpChannel.handle (HttpChannel. java:375)

at org.eclipse.jetty.server.HttpConnection.onFillable (HttpConnection. java:270)

at org.eclipse.jetty.io.AbstractConnection$ReadCallback.succeeded (AbstractConnection. java:311)

at org.eclipse.jetty.io.FillInterest.fillable(FillInterest.java:103)

at org.eclipse.jetty.io.ChannelEndPoint$2.run (ChannelEndPoint. java:117)

at org.eclipse.jetty.util.thread.strategy.EatWhatYouKill.runTask (EatWhatYouKill. java:336)

at org.eclipse.jetty.util.thread.strategy.EatWhatYouKill.doProduce (EatWhatYouKill. java:313)

at org.eclipse.jetty.util.thread.strategy.EatWhatYouKill.tryProduce (EatWhatYouKill.java:171)

at org.eclipse.jetty.util.thread.strategy.EatWhatYouKill.run (EatWhatYouKill. java:129)

at org.eclipse.jetty.util.thread.ReservedThreadExecutor$ReservedThread.run (ReservedThreadExecutor.
java:388)

at org.eclipse.jetty.util.thread.QueuedThreadPool.runJob (QueuedThreadPool. java:806)

at org.eclipse.jetty.util.thread.QueuedThreadPoolS$Runner.run (QueuedThreadPool. java:938)

at java.lang.Thread.run (Thread. java:748)

at org.springframework.remoting.support.RemoteInvocationUtils.fillInClientStackTraceIfPossible (Rem
oteInvocationUtils.java:45)

at org.springframework.remoting.support.RemoteInvocationResult.recreate (RemoteInvocationResult. jav
a:149)

at org.springframework.remoting.support.RemoteInvocationBasedAccessor.recreateRemoteInvocationResu
1t (RemoteInvocationBasedAccessor. java:85)

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.invoke (HttpInvokerClientI
nterceptor.java:158)
at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation
.java:179)
at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:213)
at com.sun.proxy.S$SProxy6l.mergeDescriptions (Unknown Source)
at eu.etaxonomy.taxeditor.editor.descriptiveDataSet.matrix.CharacterMatrixPart.save (CharacterMatri
xPart.java:221)
at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)
at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
at java.lang.reflect.Method.invoke (Method. java:498)
at org.eclipse.ed.core.internal.di.MethodRequestor.execute (MethodRequestor.java:55)

48 more
Caused by: org.hibernate.exception.ConstraintViolationException: could not execute statement
at org.hibernate.exception.internal.SQLExceptionTypeDelegate.convert (SQLExceptionTypeDelegate. java
:59)
at org.hibernate.exception.internal.StandardSQLExceptionConverter.convert (StandardSQLExceptionConv
erter.java:42)
at org.hibernate.engine. jdbc.spi.SglExceptionHelper.convert (SglExceptionHelper. java:111)
at org.hibernate.engine. jdbc.spi.SglExceptionHelper.convert (SglExceptionHelper. java:97)
at org.hibernate.engine. jdbc.internal.ResultSetReturnImpl.executeUpdate (ResultSetReturnImpl. java:2
07)
at org.hibernate.engine. jdbc.batch.internal.NonBatchingBatch.addToBatch (NonBatchingBatch. java:45)
at org.hibernate.persister.entity.AbstractEntityPersister.insert (AbstractEntityPersister.java:3013
)
at org.hibernate.persister.entity.AbstractEntityPersister.insert (AbstractEntityPersister.java:3513
)
at org.hibernate.action.internal.EntityInsertAction.execute (EntityInsertAction. java:89)
at org.hibernate.engine.spi.ActionQueue.executeActions (ActionQueue. java:589)
at org.hibernate.engine.spi.ActionQueue.executeActions (ActionQueue. java:463)
at org.hibernate.event.internal.AbstractFlushingEventListener.performExecutions (AbstractFlushingEv
entListener. java:337)
at org.hibernate.event.internal.DefaultFlushEventListener.onFlush (DefaultFlushEventListener. java:3
9)
at org.hibernate.internal.SessionImpl.flush (SessionImpl.java:1295)
at org.hibernate.internal.SessionImpl.managedFlush (SessionImpl. java:468)
at org.hibernate.internal.SessionImpl.flushBeforeTransactionCompletion (SessionImpl. java:3159)
at org.hibernate.internal.SessionImpl.beforeTransactionCompletion (SessionImpl.java:2352)
at org.hibernate.engine. jdbc.internal.JdbcCoordinatorImpl.beforeTransactionCompletion (JdbcCoordina
torImpl.java:491)
at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelocalTransactionCoordinato
rImpl.beforeCompletionCallback (JdbcResourcelLocalTransactionCoordinatorImpl. java:147)
at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelocalTransactionCoordinato
rImpl.access$100 (JdbcResourcelLocalTransactionCoordinatorImpl. java:38)
at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelLocalTransactionCoordinato
rImplS$TransactionDriverControlImpl.commit (JdbcResourcelLocalTransactionCoordinatorImpl. java:231)
at org.hibernate.engine.transaction.internal.TransactionImpl.commit (TransactionImpl. java:65)
at org.springframework.orm.hibernateb5.HibernateTransactionManager.doCommit (HibernateTransactionMan
ager.java:582)

168 more
Caused by: java.sqgl.SQLIntegrityConstraintViolationException: Duplicate entry 'bfc52e52-bf25-4562-
ba0l-7344a221la2ce' for key 'UK_b8inp8ckel89cpod7euwnlObgf'
at com.mysgl.cj.jdbc.exceptions.SQLError.createSQLException (SQLError. java:117)
at com.mysgl.cj.jdbc.exceptions.SQLError.createSQLException (SQLError. java:97)
at com.mysgl.cj.jdbc.exceptions.SQLExceptionsMapping.translateException (SQLExceptionsMapping. java:
122)
at com.mysgl.cj.jdbc.ClientPreparedStatement.executeInternal (ClientPreparedStatement. java:953)
at com.mysgl.cj.jdbc.ClientPreparedStatement.executeUpdateInternal (ClientPreparedStatement. java:10
92)
at com.mysgl.cj.jdbc.ClientPreparedStatement.executeUpdatelInternal (ClientPreparedStatement. java:10
40)
at com.mysgl.cj.jdbc.ClientPreparedStatement .executelLargeUpdate (ClientPreparedStatement. java:1347)
at com.mysgl.cj.jdbc.ClientPreparedStatement .executeUpdate (ClientPreparedStatement.java:1025)
at com.mchange.v2.c3p0.impl.NewProxyPreparedStatement.executeUpdate (NewProxyPreparedStatement. java
:384)
at org.hibernate.engine. jdbc.internal.ResultSetReturnImpl.executeUpdate (ResultSetReturnImpl. java:2
04)

04/23/2024 5/9




186 more

Related issues:
Copied to EDIT - bug #9772: Improve DTO usage for character matrix Closed

Associated revisions

Revision f9e1b92e - 08/16/2021 12:30 PM - Katja Luther

ref #9710: update descriptions of matrix after save

Revision 7f7f914d - 08/17/2021 02:15 PM - Katja Luther
ref #9710: update the dtos after merge

Revision 79f6eb28 - 08/18/2021 11:32 AM - Katja Luther

ref #9710: further work to avoid constraint violation exception

Revision 71559ffe - 09/15/2021 12:29 PM - Katja Luther

ref #9710: switch to dtos for descriptive data set and descriptions for character matrix

Revision 66889a42 - 09/15/2021 01:00 PM - Katja Luther

ref #9710: do not use cdm objects for dds and descriptions in character matrix

Revision 5bf13b75 - 09/15/2021 01:32 PM - Katja Luther
ref #9710: missed adaption in StructuredAggregationConfigurationWizard

Revision 10f4a3fd - 09/20/2021 10:11 AM - Katja Luther
ref #9710: avoid NPEs

History

#1 - 08/16/2021 11:20 AM - Katja Luther

This problem seems to appear when adding a new specimen, save and enter other data to this new description and save again.

#2 - 08/16/2021 11:21 AM - Katja Luther

- Status changed from New to In Progress

#3 - 09/17/2021 09:56 PM - Andreas Miiller
- Status changed from In Progress to Resolved

- % Done changed from 0 to 30

| put this to resolved as it is easier to find during review this way. We may split the ticket after release if not fully ready until then.

#4 - 09/17/2021 09:56 PM - Andreas Miller

- Assignee changed from Katja Luther to Andreas Mdiller

#5 - 09/17/2021 10:16 PM - Andreas Miller

Loading seems to be much faster now. Very good!

#6 - 09/17/2021 10:29 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther

Playing around | got

last remote method : http://test.e-taxonomy.eu:80/cdmserver/rem_conf_am/remoting/taxonnode.service
last remote request client time : 2021-09-17T22:21:13.761

last remote request response header time : Fri, 17 Sep 2021 20:21:14 GMT

client error time : 2021-09-17T22:21:44.808

login : admin

editor version : 5.27.0.202109161022

server : test.e-taxonomy.eu (edit-test) / rem_conf_am
schema version : 5.27.0.0.20210913
os : Windows Server 2012 R2 6.3 amdo64
Java : 1.8.0_131
java.lang.NullPointerException

at eu.etaxonomy.taxeditor.editor.descriptiveDataSet.matrix.CharacterMatrixConfigLabelAccumulator.hasDefaul
tValue (CharacterMatrixConfigLabelAccumulator. java:173)

at eu.etaxonomy.taxeditor.editor.descriptiveDataSet.matrix.CharacterMatrixConfigLabelAccumulator.hasDefaul
tValue (CharacterMatrixConfigLabelAccumulator. java:154)

at eu.etaxonomy.taxeditor.editor.descriptiveDataSet.matrix.CharacterMatrixConfigLabelAccumulator.accumulat
eConfigLabels (CharacterMatrixConfigLabelAccumulator. java:113)

at org.eclipse.nebula.widgets.nattable.layer.AbstractLayer.getConfigLabelsByPosition (AbstractLayer. java:1ll
0)

at org.eclipse.nebula.widgets.nattable.layer.AbstractLayerTransform.getConfigLabelsByPosition (AbstractLaye
rTransform. java:335)

at org.eclipse.nebula.widgets.nattable.layer.AbstractLayerTransform.getConfigLabelsByPosition (AbstractLaye
rTransform. java:335)

Probably DescriptionBaseDto.getElements() should never return null but empty List instead. This should be verified in the constructor already (similar
to model objects). Then you can also remove the "elements = new ArrayList<>();" in addElement() in case elements is null.

#7 - 09/17/2021 10:34 PM - Andreas Miiller

| get the strange behavior that the matrix only shows the most left factual data column correctly. All other columns are grey though they contain data.
When | scroll to the right and a new column is the most left column this column shows the data, etc.

Looks like this:

dentifier Land ird property ... apocarp third .

100558969  Germany 55 cm Q
10 0667861 China —_
18 0019227 Germany

10 0020910 Germany 66 cm
10 0463073 Germany
10 0553079 Germany
10 0553448 Germany

18 0020703 Germany M em
18 0020749 Germany 45cm
155

#8 - 09/17/2021 10:49 PM - Andreas Miiller
- File picture189-1.png added

#9 - 09/17/2021 11:13 PM - Andreas Miller

Also | get (during save | think, but not sure)

last remote method : http://test.e-taxonomy.eu:80/cdmserver/rem_conf_am/remoting/common.service
last remote request client time : 2021-09-17T22:32:33.565

last remote request response header time : Fri, 17 Sep 2021 20:32:33 GMT
client error time : 2021-09-17T22:32:33.596

login : admin

editor version : 5.27.0.202109161022

server : test.e-taxonomy.eu (edit-test) / rem_conf_am

schema version : 5.27.0.0.20210913

os : Windows Server 2012 R2 6.3 amd64

java : 1.8.0_131

org.eclipse.ed.core.di.InjectionException: java.lang.NullPointerException

04/23/2024 7/9



at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at

org.eclipse.ed.core.internal.di.MethodRequestor.execute (MethodRequestor. java:65)
org.eclipse.ed.core.internal.di.InjectorImpl.invokeUsingClass (InjectorImpl. java:282)
org.eclipse.ed.core.internal.di.InjectorImpl.invoke (InjectorImpl. java:247)
org.eclipse.ed.core.contexts.ContextInjectionFactory.invoke (ContextInjectionFactory. java:90)
org.eclipse.ed4.ui.internal.workbench.PartServiceSaveHandler.save (PartServiceSaveHandler. java:57)
org.eclipse.ui.internal.WorkbenchWindow$7.save (WorkbenchWindow. java:594)
org.eclipse.ed.ui.internal.workbench.PartServiceImpl.savePart (PartServiceImpl. java:1390)
eu.etaxonomy.taxeditor.workbench.SaveHandler.execute (SaveHandler. java:38)
sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)
sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method.invoke (Method. java:498)
org.eclipse.ed.core.internal.di.MethodRequestor.execute (MethodRequestor. java:55)
org.eclipse.ed.core.internal.di.InjectorImpl.invokeUsingClass (InjectorImpl. java:282)
org.eclipse.ed.core.internal.di.InjectorImpl.invoke (InjectorImpl. java:264)
org.eclipse.ed.core.contexts.ContextInjectionFactory.invoke (ContextInjectionFactory. java:132)
org.eclipse.ed.core.commands.internal.HandlerServiceHandler.execute (HandlerServiceHandler. java:152)
org.eclipse.core.commands.Command.executeWithChecks (Command. java:494)
org.eclipse.core.commands.ParameterizedCommand.executeWithChecks (ParameterizedCommand. java:488)
org.eclipse.ed4.core.commands.internal.HandlerServiceImpl.executeHandler (HandlerServiceImpl. java:210)
org.eclipse.ed.ui.workbench.renderers.swt.HandledContributionItem.executeItem(HandledContributionItem. j

ava:433)

at

org.eclipse.ed4.ui.workbench.renderers.swt.AbstractContributionItem.handleWidgetSelection (AbstractContri

butionItem. java:454)

at

org.eclipse.ed.ui.workbench.renderers.swt.AbstractContributionItem$3.handleEvent (AbstractContributionIt

em. java:482)

at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at

at
at
at
at
at
at
at
at
at
at
Caused
at
at
at

org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)
org.eclipse.swt.widgets.Display.sendEvent (Display.java:4418)
org.eclipse.swt.widgets.Widget.sendEvent (Widget. java:1079)
org.eclipse.swt.widgets.Display.runDeferredEvents (Display.java:4236)
org.eclipse.swt.widgets.Display.readAndDispatch (Display. java:3824)
org.eclipse.ed4.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderingEngine. java:1121)
org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)
org.eclipse.e4.ui.internal.workbench.swt.PartRenderingEngine.run (PartRenderingEngine. java:1022)
org.eclipse.ed4.ui.internal.workbench.E4Workbench.createAndRunUI (E4Workbench. java:150)
org.eclipse.ui.internal.Workbench$5.run (Workbench. java:693)
org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)
org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:610)
org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:148)
eu.etaxonomy.taxeditor.Application.start (Application.java:20)
org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle. java:196)
org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLauncher. java:134

org.eclipse.core.runtime.internal.adaptor.EclipseApplauncher.start (EclipseAppLauncher. java:104)
org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:388)
org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:243)
sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)
sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method.invoke (Method. java:498)
org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:673)
org.eclipse.equinox.launcher.Main.basicRun (Main. java:610)
org.eclipse.equinox.launcher.Main.run (Main. java:1519)

by: java.lang.NullPointerException
eu.etaxonomy.cdm.persistence.dto.TermDto.fromTerm (TermDto. java:85)
eu.etaxonomy.cdm.persistence.dto.TermDto.fromTerm (TermDto. java:73)
eu.etaxonomy.cdm.api.service.dto.StatisticalMeasurementValueDto.fromStatisticalMeasurementValue (Statist

icalMeasurementValueDto. java:34)

at
at
at

va:249)

at
at
at
at
at

eu.etaxonomy.cdm.api.service.dto.QuantitativeDataDto.fromQuantitativeData (QuantitativeDataDto.java:46)
eu.etaxonomy.cdm.api.service.dto.DescriptionBaseDto.fromDescription (DescriptionBaseDto. java:249)
eu.etaxonomy.taxeditor.editor.descriptiveDataSet.matrix.CharacterMatrixPart.save (CharacterMatrixPart. ja

sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)
sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method.invoke (Method. java:498)
org.eclipse.ed.core.internal.di.MethodRequestor.execute (MethodRequestor. java:55)

48 more

This looks like dirty data but | updated all data before to not have null value for StatisticalMeasurement.type .
After this that database was again filled with statistcalMeasurment data having no type (new records as far as | can see).

#10 - 09/17/2021 11:16 PM - Andreas Miiller

| worked with 5.27.0.202109161022 beta as there is no newer version for nightly (build does not work). Also the current local version does not work
against the test server.

#11 - 09/20/2021 10:06 AM - Katja Luther
- File picture019-1.png added

Andreas Muller wrote:

| get the strange behavior that the matrix only shows the most left factual data column correctly. All other columns are grey though they contain
data. When | scroll to the right and a new column is the most left column this column shows the data, etc.

Looks like this:

Strange, locally this behaviour does not appear, need to check whether | have missed to check in some files.

leaf
Unit Sammler + Nr Identifier Land ]
leaf leaf arrangeme... leaf maximum ... leaf shape
1 4 Acanthocere...
2 4 Acanthoce...
3 =469 Honduras, Franc... Honduras absent agglomerated, a... 8 acerose, aculeat
4 4 Acanthoce...
5 #471 Mexica, 30 km N... 159005 Mexico absent acyclic 58
6 ¥ Acanthoce...
7 ¥ Acanthoce...
8 ¥ Acanthoce...
] » Acanthoce...
10 » Acanthoce...
| also checked the actual nightly build and your test DB and all values are shown.
Now | could reproduce this behaviour, if a second exact value with min/max is added, the type is set to null...
#12 - 09/20/2021 01:58 PM - Andreas Miiller
- Copied to bug #9772: Improve DTO usage for character matrix added
#13 - 09/20/2021 02:00 PM - Andreas Miiller
- Status changed from Feedback to Closed
- % Done changed from 30 to 100
further discussions on DTO handling were moved to #9772.
This ticket can be closed as it originally handles only the exception.
Please reopen if you think something is still missing.
#14 - 09/21/2021 02:11 PM - Andreas Miiller
- Target version changed from Release 5.45 to Release 5.27
Files
picture189-1.png 14.3 KB 09/17/2021 Andreas Mdiller
picture019-1.png 12.7 KB 09/20/2021 Katja Luther
